Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMETX.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMETX.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMETX.m	(revision 636)
@@ -1,4 +1,20 @@
-PXRMETX ; SLC/PJH - Run Extract for QUERI ;07/10/2007
- ;;2.0;CLINICAL REMINDERS;**4,6**;Feb 04, 2005;Build 123
+PXRMETX ; SLC/PJH - Run Extract for QUERI ;1/22/07  21:25
+ ;;2.0;CLINICAL REMINDERS;**4,7**;Feb 04, 2005;Build 14
+ ; Modified from FOIA VISTA,
+ ; Copyright (C) 2007 WorldVistA
+ ;
+ ; This program is free software; you can redistribute it and/or modify
+ ; it under the terms of the GNU General Public License as published by
+ ; the Free Software Foundation; either version 2 of the License, or
+ ; (at your option) any later version.
+ ;
+ ; This program is distributed in the hope that it will be useful,
+ ; but WITHOUT ANY WARRANTY; without even the implied warranty of
+ ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ ; GNU General Public License for more details.
+ ;
+ ; You should have received a copy of the GNU General Public License
+ ; along with this program; if not, write to the Free Software
+ ; Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
  ;
 AUTO(ID,PURGE) ;Called from option scheduling (#19.2)
@@ -18,4 +34,6 @@
  ;Purge Patient Lists
  D PRGPL^PXRMETXU
+ ;Call the DOQ-IT HL7 generating routine
+ ;D EXTRACT^VEPER7EX(VDATA(810.2,IEN_",",3,"I"),VDATA(810.2,IEN_",",5,"I"))
  Q
  ;
@@ -53,4 +71,24 @@
  Q
  ;
+ACAD ;Auto CAD entry point
+ D AUTO("VOE DOQ-IT CAD EXTRACTION")
+ Q
+ ;
+ADM ;Auto DM entry point
+ D AUTO("VOE DOQ-IT DM EXTRACTION")
+ Q
+ ;
+AHF ;Auto HF entry point
+ D AUTO("VOE DOQ-IT HF EXTRACTION")
+ Q
+ ;
+AHTN ;Auto HTN entry point
+ D AUTO("VOE DOQ-IT HTN EXTRACTION")
+ Q
+ ;
+APC ;Auto PC entry point
+ D AUTO("VOE DOQ-IT PC EXTRACTION")
+ Q
+ ;
 RUN(IEN,NEXT,MODE,PURGE) ;Process extract parameter
  ; IEN is ien of Extract Parameter
@@ -62,6 +100,5 @@
  ;
  N CLASS,FDA,FDAIEN,MSG
- N PXRMIDOD,PXRMLIST,PXRMNODE,PXRMRULE,PXRMSTRT,PXRMXIEN,PATCREAT,XNAME
- N ITER
+ N PXRMLIST,PXRMNODE,PXRMRULE,PXRMSTRT,PXRMXIEN,PATCREAT,XNAME
  ;Initialise
  K ^TMP("PXRMETX",$J),^TMP("PXRMETX1",$J)
@@ -83,6 +120,4 @@
  ;Determine output name for patient list and extract summary
  S XNAME=NAME_" "_YEAR_" "_PERIOD
- S NAME=$$GETNAME(XNAME)
- S ITER=$P(NAME,"/",2)
  ;Process (single) Denominator rule into patient list
  N SEQ,SUB
@@ -98,18 +133,14 @@
  .S INTP=+$P(DATA,U,5)
  .;Create new patient list
- .I ITER'="" S LIST=LIST_"/"_ITER
- .S PATCREAT="Y",PXRMLIST=$$CRLST^PXRMRUL1(LIST,CLASS) Q:'PXRMLIST
+ .S PATCREAT="Y",PXRMLIST=$$CRLST^PXRMRULE(LIST,CLASS) Q:'PXRMLIST
  .;
- .D START^PXRMRULE(PXRMRULE,PXRMLIST,PXRMNODE,PXRMSTRT,PXRMSTOP,IEN,YEAR,PERIOD,INDP,INTP,ITER)
+ .D START^PXRMRULE(PXRMRULE,PXRMLIST,PXRMNODE,PXRMSTRT,PXRMSTOP,IEN,YEAR,PERIOD,INDP,INTP)
  .;Clear ^TMP lists created for rule
  .D CLEAR^PXRMRULE(PXRMRULE,PXRMNODE)
  .;Process reminders and finding rules
- .;If include deceased patients is true then set the flag so reminders
- .;will be evaluated for deceased patients.
- .S PXRMIDOD=$S(INDP:1,1:0)
  .D REM^PXRMETXR(SUB,PXRMLIST,PXRMSTRT,PXRMSTOP,PARTYPE)
  ;
  ;Get the name
- ;S NAME=$$GETNAME(XNAME)
+ S NAME=$$GETNAME(XNAME)
  ;Create extract summary entry
  S FDA(810.3,"+1,",.01)=NAME
@@ -133,4 +164,6 @@
  ;Transmit results
  I (MODE=0)!(MODE=2) D TRANS(FDAIEN(1))
+ ;
+ I $$GET^XPAR("SYS","DOQ-IT")="YES" D EXTRACT^VEPER7EX(VDATA(810.2,IEN_",",3,"I"),VDATA(810.2,IEN_",",5,"I"),PXRMLIST)
  ;
  ;Update extract parameters
Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMETXR.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMETXR.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMETXR.m	(revision 636)
@@ -1,4 +1,4 @@
-PXRMETXR ; SLC/PJH,PKR - Reminder section of extract ;02/22/2007
- ;;2.0;CLINICAL REMINDERS;**4,6**;Feb 04, 2005;Build 123
+PXRMETXR ; SLC/PJH,PKR - Reminder section of extract ;05/01/2006
+ ;;2.0;CLINICAL REMINDERS;**4**;Feb 04, 2005;Build 21
  ; 
  ; Called from PXRMETX
@@ -115,5 +115,5 @@
  ;lists.
  N APPL,DATA,DEFARR,DEFSITE,DFN,DUE,FIEV,FRIEN,FUTIL,IND,INST
- N PXRMDATE,RCNT,REM,REMSEQ,RIEN,RNAM,STATUS,SUB1,TODAY
+ N PXRMDATE,RCNT,REM,RIEN,RNAM,STATUS,SUB1,TODAY
  N END,START
  ;S START=$H
@@ -123,23 +123,20 @@
  ;Scan reminders for this parameter set
  S (RCNT,SUB1)=0
- S REMSEQ=""
- F  S REMSEQ=$O(^PXRM(810.2,IEN,10,SUB,10,"B",REMSEQ)) Q:REMSEQ=""  D
- .F  S SUB1=$O(^PXRM(810.2,IEN,10,SUB,10,"B",REMSEQ,SUB1)) Q:'SUB1  D
- ..S DATA=$G(^PXRM(810.2,IEN,10,SUB,10,SUB1,0)) Q:DATA=""
- ..;Reminder ien
- ..S RIEN=$P(DATA,U,2) Q:'RIEN
- ..;Evaluation date is period end except if the period is incomplete.
- ..S PXRMDATE=$S($$FMDIFF^XLFDT(PXRMSTOP,TODAY,2)>0:TODAY,1:PXRMSTOP)
- ..;Finding Rule
- ..S FRIEN=$P(DATA,U,3)
- ..;Reminder print name
- ..S RNAM=$P($G(^PXD(811.9,RIEN,0)),U,3)
- ..I RNAM="" S RNAM=$P(^PXD(811.9,RIEN,0),U,1)
- ..;Save details to REM array
- ..S RCNT=RCNT+1,REM(RCNT)=RIEN_U_RNAM_U_FRIEN
- ..;Build list of terms from extract finding rule #810.7
- ..I FRIEN D FRULE(FRIEN,RCNT,SEQ,.REM,.FUTIL) Q
- ..;If no extract finding rule defined collect all findings in reminder
- ..I 'FRIEN D REMF(RIEN,RCNT,SEQ,.REM)
+ F  S SUB1=$O(^PXRM(810.2,IEN,10,SUB,10,SUB1)) Q:'SUB1  D
+ .S DATA=$G(^PXRM(810.2,IEN,10,SUB,10,SUB1,0)) Q:DATA=""
+ .;Reminder ien
+ .S RIEN=$P(DATA,U,2) Q:'RIEN
+ .;Evaluation date is period end except if the period is incomplete.
+ .S PXRMDATE=$S($$FMDIFF^XLFDT(PXRMSTOP,TODAY,2)>0:TODAY,1:PXRMSTOP)
+ .;Finding Rule
+ .S FRIEN=$P(DATA,U,3)
+ .;Reminder print name
+ .S RNAM=$P($G(^PXD(811.9,RIEN,0)),U,3)
+ .;Save details to REM array
+ .S RCNT=RCNT+1,REM(RCNT)=RIEN_U_RNAM_U_FRIEN
+ .;Build list of terms from extract finding rule #810.7
+ .I FRIEN D FRULE(FRIEN,RCNT,SEQ,.REM,.FUTIL) Q
+ .;If no extract finding rule defined collect all findings in reminder
+ .I 'FRIEN D REMF(RIEN,RCNT,SEQ,.REM)
  ;
  ;Process patient list
Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMETXU.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMETXU.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMETXU.m	(revision 636)
@@ -1,4 +1,4 @@
-PXRMETXU ; SLC/PJH - Extract utilities ;09/06/2007
- ;;2.0;CLINICAL REMINDERS;**4,6**;Feb 04, 2005;Build 123
+PXRMETXU ; SLC/PJH - Extract utilities ;08/03/2005
+ ;;2.0;CLINICAL REMINDERS;**4**;Feb 04, 2005;Build 21
  ;
 HELP(CALL) ;General help text routine
@@ -13,33 +13,9 @@
  I CALL=4 D
  .S HTEXT(1)="The selected period is the same as next scheduled extract."
- .S HTEXT(2)="Enter 'Y' if this extract will replace the scheduled"
+ .S HTEXT(2)="Enter 'Y' to if this extract will replace the scheduled"
  .S HTEXT(3)="extract. Enter 'N' if you still want the scheduled extract"
- .S HTEXT(4)="to run."
+ .S HTEXT(3)="to run."
  ;
  D HELP^PXRMEUT(.HTEXT)
- Q
- ;
-DELETE(IEN) ;Delete an extract summary.
- I IEN="" Q
- N DA,DELOK,DIK,NAME
- S DELOK=1
- S NAME=$P(^PXRMXT(810.3,IEN,0),U,1)
- ;Must have PXRM MANAGER key in order to delete national extracts.
- I $P($G(^PXRMXT(810.3,IEN,100)),U,1)="N" D
- . S DELOK=$S($D(^XUSEC("PXRM MANAGER",DUZ)):1,1:0)
- . I 'DELOK D
- .. W !!,NAME," is national."
- .. W !,"You cannot delete a national extract summary."
- .. H 2
- I 'DELOK Q
- ;Double check the user really wants to delete.
- S TEXT="Are you sure you want to delete "_NAME
- S DELOK=$$ASKYN^PXRMEUT("N","Are you sure you want to delete "_NAME)
- I 'DELOK Q
- S DA=IEN
- S DIK="^PXRMXT(810.3,"
- D ^DIK
- W !,"Deleting ",NAME
- H 2
  Q
  ;
Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEUT.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMEUT.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEUT.m	(revision 636)
@@ -1,4 +1,4 @@
-PXRMEUT ; SLC/PJH - General extract utilities ;09/06/2007
- ;;2.0;CLINICAL REMINDERS;**4,6**;Feb 04, 2005;Build 123
+PXRMEUT ; SLC/PJH - General extract utilities ;06/27/2006
+ ;;2.0;CLINICAL REMINDERS;**4**;Feb 04, 2005;Build 21
  ;
  ;=================================================
@@ -162,11 +162,18 @@
  ;
  ;=================================================
-HELP(HTEXT) ;General help text output routine.
- N IND,NIN,NOUT,TEXTIN,TEXOUT
- ;Make sure the text is in a form the formatting routine can handle.
- S IND="",NIN=0
- F  S IND=$O(HTEXT(IND)) Q:IND=""  S NIN=NIN+1,TEXTIN(NIN)=HTEXT(IND)
- D FORMAT^PXRMTEXT(1,72,NIN,.TEXTIN,.NOUT,.TEXTOUT)
- F IND=1:1:NOUT W !,TEXTOUT(IND)
+HELP(HTEXT) ;General help text routine. Write out the text in the HTEXT
+ ;array.
+ N DIWF,DIWL,DIWR,IC,X
+ S DIWF="C70",DIWL=0,DIWR=70
+ K ^UTILITY($J,"W")
+ S IC=""
+ F  S IC=$O(HTEXT(IC)) Q:IC=""  D
+ . S X=HTEXT(IC)
+ . D ^DIWP
+ W !
+ S IC=0
+ F  S IC=$O(^UTILITY($J,"W",0,IC)) Q:IC=""  D
+ . W !,^UTILITY($J,"W",0,IC,0)
+ K ^UTILITY($J,"W")
  W !
  Q
Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEUT1.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMEUT1.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEUT1.m	(revision 636)
@@ -1,25 +1,11 @@
-PXRMEUT1 ; SLC/PKR - General extract utilities ;05/08/2007
- ;;2.0;CLINICAL REMINDERS;**4,6**;Feb 04, 2005;Build 123
+PXRMEUT1 ; SLC/PKR - General extract utilities ;08/09/2006
+ ;;2.0;CLINICAL REMINDERS;**4**;Feb 04, 2005;Build 21
  ;=================================================
-CLDATES ;Cleanup entries in ^TMP("PXRMDDOC",$J) before making date checks.
- ;For drug findings consolidate PS(55, PS(55NVA, and PSRX( back to
- ;PSDRUG(.
- N FI,FIND0,ITEM,GLOBAL,LIST
- S FIND0=""
- F  S FIND0=$O(^TMP("PXRMDDOC",$J,FIND0)) Q:FIND0=""  D
- . S FI=$P(FIND0,U,1)
- . S GLOBAL=$P(FI,";",2)
- . I GLOBAL'["PS" Q
- . S GLOBAL="PSDRUG("
- . S ITEM=$P(FI,";",1)
- . S FI=ITEM_";"_GLOBAL_U_$P(FIND0,U,2,11)
- . S LIST(FIND0)=FI
- ;
- S FIND0=""
- F  S FIND0=$O(LIST(FIND0)) Q:FIND0=""  D
- . S FI=LIST(FIND0)
- . S ^TMP("PXRMDDOC",$J,FI)=^TMP("PXRMDDOC",$J,FIND0)
- . K ^TMP("PXRMDDOC",$J,FIND0)
- Q
+DCONV(DATE,LBBDT,LBEDT) ;Convert dates to actual values.
+ I DATE=0 Q DATE
+ N PXRMDATE
+ S PXRMDATE=$S(DATE["BDT":LBBDT,1:LBEDT)
+ S DATE=$$STRREP^PXRMUTIL(DATE,"BDT","T")
+ Q $$CTFMD^PXRMDATE(DATE)
  ;
  ;=================================================
@@ -36,17 +22,8 @@
  ;
  ;=================================================
-DCONV(DATE,LBBDT,LBEDT) ;Convert dates to actual values.
- I DATE=0 Q DATE
- N PXRMDATE
- S PXRMDATE=$S(DATE["BDT":LBBDT,1:LBEDT)
- S DATE=$$STRREP^PXRMUTIL(DATE,"BDT","T")
- Q $$CTFMD^PXRMDATE(DATE)
- ;
- ;=================================================
 DOCDATES(RULESET,LBBDT,LBEDT,NL,OUTPUT) ;
- N EM,FRACT,FRDATA,FRDATES,FRIEN,FRLST,FRLIEN,FROLST,FROUT,FRPAT
- N FRPERM,FRSTRT,FRTIEN,FRTYP,FSEQ,OPER,PXRMFVPL
+ N FINDPA,FRACT,FRDATA,FRDATES,FRIEN,FRLST,FRLIEN,FROLST,FROUT,FRPAT
+ N FRPERM,FRSTRT,FRTIEN,FRTYP,FSEQ,PXRMDATE,PXRMFVPL
  N RRIEN,RSDATA,RSDATES,RBDT,REDT,SEQ,SUB
- I $G(PXRMDDOC)=2 D CLDATES
  ;Build the variable pointer list.
  D BLDRLIST^PXRMVPTR(811.902,.01,.PXRMFVPL)
@@ -55,6 +32,4 @@
  . S SUB=$O(^PXRM(810.4,RULESET,30,"B",SEQ,"")) Q:'SUB
  . S RSDATA=$G(^PXRM(810.4,RULESET,30,SUB,0)) Q:RSDATA=""
- . S OPER=$P(RSDATA,U,3)
- . S OPER=$$EXTERNAL^DILFD(810.41,.03,"",OPER,.EM)
  . S RSDATES=$G(^PXRM(810.4,RULESET,30,SUB,1))
  .;Finding rule ien.
@@ -69,46 +44,31 @@
  .;Determine RBDT and REDT
  . D RDATES(RSDATES,FRDATES,LBBDT,LBEDT,.RBDT,.REDT)
+ . S PXRMDATE=LBEDT
+ . S $P(FINDPA(0),U,8)=RBDT,$P(FINDPA(0),U,11)=REDT
  . S NL=NL+1,OUTPUT(NL)=""
  . S NL=NL+1,OUTPUT(NL)="SEQUENCE "_SEQ_" "_$P(FRDATA,U,1)
- . S NL=NL+1,OUTPUT(NL)=" Operation: "_OPER
  .;Term finding rules
- . I FRTYP=1 D TERM(FRTIEN,LBBDT,LBEDT,RBDT,REDT,.PXRMFVPL,.NL,.OUTPUT)
+ . I FRTYP=1 D TERM(FRTIEN,.FINDPA,.PXRMFVPL,.NL,.OUTPUT)
  .;Reminder Definition List Rule
- . I FRTYP=2 D REM(RRIEN,LBBDT,LBEDT,RBDT,REDT,.PXRMFVPL,.NL,.OUTPUT)
+ . I FRTYP=2 D REM(RRIEN,.FINDPA,.PXRMFVPL,.NL,.OUTPUT)
  Q
  ;
  ;=================================================
-FMULPRT(FARR,PXRMFVPL,NL,OUTPUT) ;Print the finding multiple
+FMULPRT(DEFARR,FINDPA,PXRMFVPL,NL,OUTPUT) ;Print the finding multiple
  ;information.
- ;Q
- N BDT,EDT,DERROR,FNAME,FTYPE,IND,NOCC,TBDT,TEDT,TEMP,VPTR
+ N BDT,EDT,FNAME,FTYPE,IND,NOCC,PFINDPA,TFINDPA,VPTR
  S IND=0
- F  S IND=+$O(FARR(20,IND)) Q:IND=0  D
- . S VPTR=$P(FARR(20,IND,0),U,1)
+ F  S IND=+$O(DEFARR(20,IND)) Q:IND=0  D
+ . S VPTR=$P(DEFARR(20,IND,0),U,1)
  . S FNAME=$$ENTRYNAM^PXRMPTD2(VPTR)
  . S FTYPE=$$FTYPE^PXRMPTD2(VPTR,1)
  . S NL=NL+1,OUTPUT(NL)="  FINDING "_IND_"-"_FTYPE_"."_FNAME
+ . K PFINDPA,TFINDPA
+ . M TFINDPA=DEFARR(20,IND)
  .;Set the finding parameters.
- . D SSPAR^PXRMUTIL(FARR(20,IND,0),.NOCC,.BDT,.EDT)
+ . D SPFINDPA^PXRMTERM(.FINDPA,.TFINDPA,.PFINDPA)
+ . D SSPAR^PXRMUTIL(PFINDPA(0),.NOCC,.BDT,.EDT)
  . S NL=NL+1,OUTPUT(NL)="   Beginning Date/Time: "_$$FMTE^XLFDT(BDT,"5Z")
  . S NL=NL+1,OUTPUT(NL)="   Ending Date/Time:    "_$$FMTE^XLFDT(EDT,"5Z")
- . I $G(PXRMDDOC)'=2 Q
- . S DERROR=0
- . S TEMP=$G(^TMP("PXRMDDOC",$J,$P(FARR(20,IND,0),U,1,11)))
- .;If TEMP is null then no evaluation was required and the check 
- .;cannot be made
- . I TEMP="" Q
- . I $P(TEMP,U,1)'=BDT D
- .. S DERROR=1
- .. S NL=NL+1,OUTPUT(NL)="  There is a consistency problem with the beginning date!"
- .. S NL=NL+1,OUTPUT(NL)="  Date used to build the list was: "_$$FMTE^XLFDT($P(TEMP,U,1),"5Z")
- . I $P(TEMP,U,2)'=EDT D
- .. S DERROR=1
- .. S NL=NL+1,OUTPUT(NL)="  There is a consistency problem with the ending date!"
- .. S NL=NL+1,OUTPUT(NL)="  Date used to build the list was: "_$$FMTE^XLFDT($P(TEMP,U,2),"5Z")
- . I DERROR D
- .. S NL=NL+1,OUTPUT(NL)="  Please notify the developers."
- .. ;S NL=NL+1,OUTPUT(NL)="  Please enter a Remedy ticket."
- .. S NL=NL+1,OUTPUT(NL)=" "
  Q
  ;
@@ -122,5 +82,5 @@
  I RBDT="" S RBDT=0
  I REDT="" S REDT=LBEDT
- I REDT=0 S REDT=DT
+ I REDT=0 S REDT=$$DT^XLFDT
  ;Convert RBDT and REDT to FileMan dates.
  S RBDT=$$DCONV(RBDT,LBBDT,LBEDT)
@@ -137,19 +97,17 @@
  ;
  ;=================================================
-REM(IEN,LBBDT,LBEDT,RBDT,REDT,PXRMFVPL,NL,OUTPUT) ;
+REM(IEN,FINDPA,PXRMFVPL,NL,OUTPUT) ;
  N DEFARR
  D DEF^PXRMLDR(IEN,.DEFARR)
- D DATES^PXRMRUL1(LBBDT,LBEDT,RBDT,REDT,.DEFARR)
  S NL=NL+1,OUTPUT(NL)=" REMINDER DEFINITION "_$P(DEFARR(0),U,1)
- D FMULPRT(.DEFARR,.PXRMFVPL,.NL,.OUTPUT)
+ D FMULPRT(.DEFARR,.FINDPA,.PXRMFVPL,.NL,.OUTPUT)
  Q
  ;
  ;=================================================
-TERM(IEN,LBBDT,LBEDT,RBDT,REDT,PXRMFVPL,NL,OUTPUT) ;
+TERM(IEN,FINDPA,PXRMFVPL,NL,OUTPUT) ;
  N TERMARR
  D TERM^PXRMLDR(IEN,.TERMARR)
- D DATES^PXRMRUL1(LBBDT,LBEDT,RBDT,REDT,.TERMARR)
  S NL=NL+1,OUTPUT(NL)=" TERM "_$P(TERMARR(0),U,1)
- D FMULPRT(.TERMARR,.PXRMFVPL,.NL,.OUTPUT)
+ D FMULPRT(.TERMARR,.FINDPA,.PXRMFVPL,.NL,.OUTPUT)
  Q
  ;
Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEVFI.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMEVFI.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEVFI.m	(revision 636)
@@ -1,4 +1,4 @@
-PXRMEVFI ; SLC/PKR - Driver for finding evaluation. ;04/02/2007
- ;;2.0;CLINICAL REMINDERS;**6**;Feb 04, 2005;Build 123
+PXRMEVFI ; SLC/PKR - Driver for finding evaluation. ;12/01/2004
+ ;;2.0;CLINICAL REMINDERS;;Feb 04, 2005
  ;
  ;=====================================================
@@ -24,5 +24,5 @@
  . I ENODE="PSNDF(50.6," D EVALFI^PXRMDGEN(DFN,.DEFARR,ENODE,.FIEVAL) Q
  . I ENODE="RAMIS(71," D EVALFI^PXRMRAD(DFN,.DEFARR,ENODE,.FIEVAL) Q
- . I ENODE="YTT(601.71," D EVALFI^PXRMMH(DFN,.DEFARR,ENODE,.FIEVAL) Q
+ . I ENODE="YTT(601," D EVALFI^PXRMMH(DFN,.DEFARR,ENODE,.FIEVAL) Q
  ;Evaluate function findings.
  D EVAL^PXRMFF(DFN,.DEFARR,.FIEVAL)
@@ -38,5 +38,5 @@
  S FINDPA(11)=DEFARR(20,FINUM,11)
  D GENTERM^PXRMPLST(FINDPA(0),FINUM,.TERMARR)
- D EVALPL^PXRMTERL(.FINDPA,.TERMARR,PLIST)
+ D EVALPL^PXRMTERM(.FINDPA,.TERMARR,PLIST)
  Q
  ;
Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXCF.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMEXCF.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXCF.m	(revision 636)
@@ -1,4 +1,4 @@
-PXRMEXCF ; SLC/PKR - Reminder exchange routines for computed findings. ;06/28/2007
- ;;2.0;CLINICAL REMINDERS;**6**;Feb 04, 2005;Build 123
+PXRMEXCF ; SLC/PKR - Reminder exchange routines for computed findings. ;12/22/2004
+ ;;2.0;CLINICAL REMINDERS;;Feb 04, 2005
  ;==============================================
 EXISTS(ROUTINE) ;Return true if routine ROUTINE exists.
@@ -10,32 +10,27 @@
  ;==============================================
 GETRACT(ATTR,NEWNAME,NAMECHG,RTN,EXISTS) ;Get the action for a routine.
- N ACTION,CHOICES,CSUM,DIR,DIROUT,DIRUT,DTOUT,DUOUT,ECS,IND,MSG
+ N ACTION,CHOICES,DIR,DIROUT,DIRUT,DTOUT,DUOUT,ECS,IND,MSG
  N PCS,ROUTINE,SAME,TEXT,X,Y
  S NEWNAME=""
+ ;If the routine exists compare the existing routine checksum with the
+ ;the checksum of the routine in the packed definition.
  S ROUTINE=ATTR("NAME")
  I EXISTS="" S EXISTS=$$EXISTS^PXRMEXCF(ROUTINE)
  S CHOICES=$S(EXISTS:"COQS",1:"CIQS")
  I EXISTS D
- .;If the routine exists compare the existing routine checksum with the
- .;the checksum of the routine in the packed definition.
- . S CSUM=$$RTNCS^PXRMEXCS(ROUTINE)
- . S SAME=$S(ATTR("CHECKSUM")=CSUM:1,1:0)
+ . S SAME=$$SAME(.ATTR,.RTN)
  . S TEXT(1)="Routine "_ROUTINE_" already exists "
- . I SAME D
- .. S TEXT(1)=TEXT(1)_"and the packed routine is identical, skipping."
- .. W !,TEXT(1),! H 2
- .. S ACTION="S"
- . I 'SAME D
- .. S TEXT(1)=TEXT(1)_"but the packed routine is different,"
- .. S TEXT(2)="what do you want to do?"
- .. W !,TEXT(1),!,TEXT(2)
- .. S DIR("B")="O"
- .. S ACTION=$$GETACT^PXRMEXIU(CHOICES,.DIR)
+ . I SAME S TEXT(1)=TEXT(1)_"and the packed routine is identical,"
+ . I 'SAME S TEXT(1)=TEXT(1)_"but the packed routine is different,"
+ . S TEXT(2)="what do you want to do?"
+ . D EN^DDIOL(.TEXT)
+ . S DIR("B")="S"
+ . S ACTION=$$GETACT^PXRMEXIU(CHOICES,.DIR)
  E  D
- . W !!,"Routine "_ROUTINE_" is new, what do you want to do?"
+ . W !!,"Routine "_ROUTINE_" is NEW, what do you want to do?"
  . S DIR("B")="I"
  . S ACTION=$$GETACT^PXRMEXIU(CHOICES,.DIR)
  ;
- I (ACTION="Q")!(ACTION="S") Q ACTION
+ I ACTION="Q" Q ACTION
  ;
  I ACTION="C" D
@@ -65,2 +60,17 @@
  Q ACTION
  ;
+ ;==============================================
+SAME(ATTR,RTN) ;Compare the existing routine and the new version
+ ;in RTN to see if they are the same.
+ N ECS,DIF,NEWCS,RT,SAME,X,XCNP
+ ;Load the existing routine into RT.
+ S XCNP=0
+ S DIF="RT("
+ S X=ATTR("NAME")
+ X ^%ZOSF("LOAD")
+ S ECS=$$ROUTINE^PXRMEXCS(.RT)
+ K RT
+ S NEWCS=$$ROUTINE^PXRMEXCS(.RTN)
+ S SAME=$S(ECS=NEWCS:1,1:0)
+ Q SAME
+ ;
Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXCS.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMEXCS.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXCS.m	(revision 636)
@@ -1,50 +1,16 @@
-PXRMEXCS ; SLC/PKR - Routines to compute checksums. ;07/27/2007
- ;;2.0;CLINICAL REMINDERS;**6**;Feb 04, 2005;Build 123
- ;====================================================
-CHECKSUM(ATTR,START,END) ;Get the the checksum for a packed reminder
- ;component and load it into the attribute array.
- N CS,LINE
- ;If checksum is in packed component return it otherwise calculate it.
- I ATTR("FILE NUMBER")=0 D
- . S LINE=^PXD(811.8,PXRMRIEN,100,START-3,0)
- . S CS=$$GETTAGV^PXRMEXU3(LINE,"<CHECKSUM>")
- . I CS="" S CS=$$PRTNCS(PXRMRIEN,START,END)
- I ATTR("FILE NUMBER")>0 D
- . S LINE=^PXD(811.8,PXRMRIEN,100,START-2,0)
- . S CS=$$GETTAGV^PXRMEXU3(LINE,"<CHECKSUM>")
- . I CS="" S CS=$$PFDACS(PXRMRIEN,START,END)
- S ATTR("CHECKSUM")=CS
- Q
- ;
- ;====================================================
-DIQOUTCS(DIQOUT) ;Return checksum for a processed DIQOUT array.
- N CS,DATA,FIELD,FNUM,IENS,IND,SFN,STRING,TARGET,TEXT,WP
- S FNUM=$O(DIQOUT(""))
- D FIELD^DID(FNUM,"EDIT HISTORY","","SPECIFIER","TARGET")
- S SFN=+$G(TARGET("SPECIFIER"))
- S (CS,FNUM)=0
- F  S FNUM=$O(DIQOUT(FNUM)) Q:FNUM=""  D
- . I FNUM=SFN Q
- . S IENS=""
- . F  S IENS=$O(DIQOUT(FNUM,IENS)) Q:IENS=""  D
- .. S FIELD=0
- .. F  S FIELD=$O(DIQOUT(FNUM,IENS,FIELD)) Q:FIELD=""  D
- ... S DATA=DIQOUT(FNUM,IENS,FIELD)
- ... S TEXT=FNUM_$L(IENS,",")_FIELD_DATA
- ... S CS=$$CRC32^XLFCRC(TEXT,CS)
- ... I DATA["WP-start" F IND=1:1:$P(DATA,"~",2) D
- .... S TEXT=DIQOUT(FNUM,IENS,FIELD,IND)
- .... S CS=$$CRC32^XLFCRC(TEXT,CS)
- Q CS
- ;
+PXRMEXCS ; SLC/PKR - Routines to compute checksums. ;12/21/2004
+ ;;2.0;CLINICAL REMINDERS;;Feb 04, 2005
  ;====================================================
 FILE(FILENUM,IEN) ;Return checksum for entry IEN in file FILENUM.
- N CS,DIQOUT,IENROOT,MSG
- D GETS^DIQ(FILENUM,IEN,"**","N","DIQOUT","MSG")
- ;Remove edit history from all reminder files.
- D RMEH^PXRMEXPU(FILENUM,.DIQOUT,1)
- ;Convert the iens to the FDA adding form.
- D CONTOFDA^PXRMEXPU(.DIQOUT,.IENROOT)
- S CS=$$DIQOUTCS(.DIQOUT)
+ N CS,LC,REF,ROOT,TARGET
+ D FILE^DID(FILENUM,"","GLOBAL NAME","TARGET")
+ S ROOT=$$CREF^DILF(TARGET("GLOBAL NAME"))
+ K ^TMP($J,"PXRMEXCS")
+ M ^TMP($J,"PXRMEXCS")=@ROOT@(IEN)
+ S REF="^TMP($J,""PXRMEXCS"")"
+ S REF=$NA(@REF)
+ S (CS,LC)=0
+ F  S REF=$Q(@REF) Q:REF'["PXRMEXCS"  S LC=LC+1,CS=CS+$$LINECS(LC,@REF)
+ K ^TMP($J,"PXRMEXCS")
  Q CS
  ;
@@ -65,5 +31,14 @@
  N CS,IND,LINE
  S (CS,IND)=0
- F  S IND=$O(@GBL@(IND)) Q:+IND=0  S LINE=@GBL@(IND),CS=$$CRC32^XLFCRC(LINE,CS)
+ F  S IND=$O(@GBL@(IND)) Q:+IND=0  S LINE=@GBL@(IND),CS=CS+$$LINECS(IND,LINE)
+ Q CS
+ ;
+ ;====================================================
+LINECS(LINENUM,STRING) ;Return checksum of line number LINEUM whose contents
+ ;is STRING.
+ N CS,IND,LEN
+ S CS=0
+ S LEN=$L(STRING)
+ F IND=1:1:LEN S CS=CS+($A(STRING,IND)*(LINENUM+IND))
  Q CS
  ;
@@ -73,31 +48,5 @@
  S NLINES=+$P($G(^XMB(3.9,XMZ,2,0)),U,3)
  S CS=0
- F IND=1:1:NLINES S LINE=$G(^XMB(3.9,XMZ,2,IND,0)),CS=$$CRC32^XLFCRC(LINE,CS)
- Q CS
- ;
- ;====================================================
-PFDACS(IEN,FDASTART,FDAEND) ;Return checksum for FDA array of packed
- ;reminder component.
- N CS,DATA,IENS,IND,JND,FIELD,FNUM,SFN,TARGET,TEMP,TEXT
- S TEMP=^PXD(811.8,IEN,100,FDASTART,0)
- S FNUM=$P(TEMP,";",1)
- D FIELD^DID(FNUM,"EDIT HISTORY","","SPECIFIER","TARGET")
- S SFN=+$G(TARGET("SPECIFIER"))
- S CS=0
- F IND=FDASTART:1:FDAEND D
- . S TEMP=^PXD(811.8,IEN,100,IND,0)
- . S DATA=$P(TEMP,"~",2,99)
- . S TEMP=$P(TEMP,"~",1)
- . S FNUM=$P(TEMP,";",1)
- . I FNUM=SFN Q
- . I FNUM="Exchange Stub" Q
- . S IENS=$P(TEMP,";",2)
- . S FIELD=$P(TEMP,";",3)
- . S TEXT=FNUM_$L(IENS,",")_FIELD_DATA
- . S CS=$$CRC32^XLFCRC(TEXT,CS)
- . I DATA["WP-start" F JND=1:1:$P(DATA,"~",2) D
- .. S IND=IND+1
- .. S TEXT=^PXD(811.8,IEN,100,IND,0)
- .. S CS=$$CRC32^XLFCRC(TEXT,CS)
+ F IND=1:1:NLINES S LINE=$G(^XMB(3.9,XMZ,2,IND,0)),CS=CS+$$LINECS(IND,LINE)
  Q CS
  ;
@@ -105,15 +54,11 @@
 ROUTINE(RA) ;Return checksum for a routine loaded in array RA. RA has the
  ;form created by ^%ZOSF("LOAD") i.e, RA(1,0) ... RA(N,0).
- N CS,IND,TEXT
+ N CS,IND,LINE
  S (CS,IND)=0
- ;Get rid of the build number on the second line.
- S RA(2,0)=$P(RA(2,0),";",1,6)
- F  S IND=$O(RA(IND)) Q:+IND=0  D
- . S TEXT=RA(IND,0)
- . S CS=$$CRC32^XLFCRC(RA(IND,0),CS)
+ F  S IND=$O(RA(IND)) Q:+IND=0  S CS=CS+$$LINECS(IND,RA(IND,0))
  Q CS
  ;
  ;====================================================
-RTNCS(ROUTINE) ;Return checksum for a routine ROUTINE.
+RTN(ROUTINE) ;Return checksum for a routine ROUTINE.
  N CS,DIF,RA,X,XCNP
  S XCNP=0
@@ -128,13 +73,2 @@
  Q CS
  ;
- ;====================================================
-PRTNCS(IEN,START,END) ;Return checksum for a packed routine.
- N CS,IND,SL,TEXT
- S CS=0,SL=START+1
- F IND=START:1:END D
- . S TEXT=^PXD(811.8,IEN,100,IND,0)
- . ;Get rid of the build number on the second line.
- . I IND=SL S TEXT=$P(TEXT,";",1,6)
- . S CS=$$CRC32^XLFCRC(TEXT,CS)
- Q CS
- ;
Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXDG.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMEXDG.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXDG.m	(revision 636)
@@ -1,7 +1,7 @@
-PXRMEXDG ;SLC/PJH - Reminder Dialog Exchange index build ;05/16/2007
- ;;2.0;CLINICAL REMINDERS;**6**;Feb 04, 2005;Build 123
+PXRMEXDG ;SLC/PJH - Reminder Dialog Exchange index build ;02/25/2004
+ ;;2.0;CLINICAL REMINDERS;;Feb 04, 2005
  ;
  ;=====================================================================
-DIALOG(RIEN,DLIST,FLIST,OLIST,TLIST,SPONLIST) ;
+DIALOG(RIEN,DLIST,FLIST,OLIST,TLIST) ;
  ;
  ;Routine to get dialog details for a given reminder
@@ -27,6 +27,5 @@
  S DCNT=0,FCNT=0,RCNT=0,TCNT=0
  ;Get details
- D GETSPON^PXRMEXPR(801.41,DIEN,.SPONLIST)
- D DGET(DIEN,.SPONLIST)
+ D DGET(DIEN)
  ;
  ;Now build the dialog list (components first)
@@ -41,16 +40,5 @@
  N CNT,COUNT,DTYP
  S COUNT=0
- F DTYP="RESULT ELEMENT" D
- .S CNT=0 F  S CNT=$O(TEMP(DTYP,CNT)) Q:CNT'>0  D
- ..S DIEN=$G(TEMP(DTYP,CNT)) Q:DIEN'>0
- ..S COUNT=COUNT+1,DLIST("DIALOG",COUNT,DIEN)=""
- ;
- F DTYP="RESULT" D
- .S CNT=0 F  S CNT=$O(TEMP(DTYP,CNT)) Q:CNT'>0  D
- ..S DIEN=$G(TEMP(DTYP,CNT)) Q:DIEN'>0
- ..S COUNT=COUNT+1,DLIST("DIALOG",COUNT,DIEN)=""
- ;
- ;F DTYP="RESULT","DIALOG" D
- F DTYP="DIALOG" D
+ F DTYP="RESULT","DIALOG" D
  .F CNT=1:1 S DIEN=$G(TEMP(DTYP,CNT)) Q:'DIEN  D
  ..S COUNT=COUNT+1,DLIST("DIALOG",COUNT,DIEN)=""
@@ -91,16 +79,15 @@
  ;Get the dialog components
  ;-------------------------
-DGET(D0,SPONLIST) ;Save dialog ien
+DGET(D0) ;Save dialog ien
  N D1
  I $G(D0)=83
  I $G(^PXRMD(801.41,D0,49))'="",$P(^PXRMD(801.41,D0,49),U,3)>0 D
- .S D1=$P($G(^PXRMD(801.41,D0,49)),U,3) D DGET1(D0,.SPONLIST) D DGET1(D1,.SPONLIST)
- E  D DGET1(D0,.SPONLIST)
- Q
-DGET1(D0,SPONLIST) ;
+ .S D1=$P($G(^PXRMD(801.41,D0,49)),U,3) D DGET1(D0) D DGET1(D1)
+ E  D DGET1(D0)
+ Q
+DGET1(D0) ;
  S DCNT=DCNT+1,DARRAY(DCNT)=D0
  ;And details (except for reminder dialog)
  I DCNT>1 D
- .D GETSPON^PXRMEXPR(801.41,D0,.SPONLIST)
  .;Finding items
  .D DFIND(D0)
@@ -119,7 +106,7 @@
  .S DDATA=$G(^PXRMD(801.41,DCOMP,0)) Q:DDATA=""
  .;Exclude national PXRM prompts
- .I +$G(PXRMINST)=0,$E(DDATA,1,4)="PXRM",$P($G(^PXRMD(801.41,DCOMP,100)),U)="N" Q
+ .I $E(DDATA,1,4)="PXRM",$P($G(^PXRMD(801.41,DCOMP,100)),U)="N" Q
  .;Sub-components
- .D DGET(DCOMP,.SPONLIST)
+ .D DGET(DCOMP)
  .;I $G(DCOMP1)'="" D DGET(DCOMP1) S DCOMP1=""
  Q
@@ -175,26 +162,19 @@
  ;---------------------------
 DRESULT(DIEN) ;
- N CNT,RIEN,RECNT,RGCNT
+ N RIEN
  ;Result Group/Element pointer
- S RECNT=$O(TEMP("RESULT ELEMENT",""),-1)
- S RGCNT=$O(TEMP("RESULT",""),-1)
- S CNT=0
- F  S CNT=$O(^PXRMD(801.41,DIEN,51,CNT)) Q:CNT'>0  D
- .S RIEN=$P($G(^PXRMD(801.41,DIEN,51,CNT,0)),U) Q:RIEN'>0
- .;S RIEN=$P($G(^PXRMD(801.41,DIEN,0)),U,15) Q:'RIEN  Q:$D(RESULT(RIEN))
- .;Result group compoments
- .N DSUB,REIEN
- .S DSUB=0
- .F  S DSUB=$O(^PXRMD(801.41,RIEN,10,DSUB)) Q:'DSUB  D
- ..;Get result element
- ..S REIEN=$P($G(^PXRMD(801.41,RIEN,10,DSUB,0)),U,2) Q:'REIEN
- ..Q:'$D(^PXRMD(801.41,REIEN,0))
- ..;If element exists get save it
- ..S RECNT=RECNT+1,TEMP("RESULT ELEMENT",RECNT)=REIEN
- ..;S RCNT=RCNT+1,OUTPUT("RESULT",RCNT)=REIEN
- .;
- .;Save result group
- .S RGCNT=RGCNT+1,TEMP("RESULT",RGCNT)=RIEN
- .;S RCNT=RCNT+1,RESULT(RIEN)="",TEMP("RESULT",RCNT)=RIEN
+ S RIEN=$P($G(^PXRMD(801.41,DIEN,0)),U,15) Q:'RIEN  Q:$D(RESULT(RIEN))
+ ;Result group compoments
+ N DSUB,REIEN
+ S DSUB=0
+ F  S DSUB=$O(^PXRMD(801.41,RIEN,10,DSUB)) Q:'DSUB  D
+ .;Get result element
+ .S REIEN=$P($G(^PXRMD(801.41,RIEN,10,DSUB,0)),U,2) Q:'REIEN
+ .Q:'$D(^PXRMD(801.41,REIEN,0))
+ .;If element exists get save it
+ .S RCNT=RCNT+1,OUTPUT("RESULT",RCNT)=REIEN
+ ;
+ ;Save result group
+ S RCNT=RCNT+1,RESULT(RIEN)="",TEMP("RESULT",RCNT)=RIEN
  Q
  ;
Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXFI.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMEXFI.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXFI.m	(revision 636)
@@ -1,4 +1,4 @@
-PXRMEXFI ; SLC/PKR/PJH - Exchange utilities for file entries.;07/05/2007
- ;;2.0;CLINICAL REMINDERS;**6**;Feb 04, 2005;Build 123
+PXRMEXFI ; SLC/PKR/PJH - Exchange utilities for file entries.;12/21/2004
+ ;;2.0;CLINICAL REMINDERS;;Feb 04, 2005
  ;==============================================
 DELALL(FILENUM,NAME) ;Delete all file entries named NAME.
@@ -17,20 +17,4 @@
  S DIK=$$ROOT^DILFD(FILENUM)
  D ^DIK
- Q
- ;
- ;==============================================
-FEIMSG(SAME,ATTR) ;Output the general file exits install message.
- N IND,NOUT,TEXT,TEXTO
- S TEXT(1)=ATTR("FILE NAME")_" entry named "_ATTR("NAME")_" already exists"
- I SAME D
- . S TEXT(2)="and the packed component is identical, skipping."
- . S TEXT(3)=" "
- . D FORMAT^PXRMTEXT(1,70,3,.TEXT,.NOUT,.TEXTO)
- . F IND=1:1:NOUT W !,TEXTO(IND)
- . H 2
- I 'SAME D
- . S TEXT(2)="but the packed component is different, what do you want to do?"
- . D FORMAT^PXRMTEXT(1,70,2,.TEXT,.NOUT,.TEXTO)
- . F IND=1:1:NOUT W !,TEXTO(IND)
  Q
  ;
@@ -73,5 +57,4 @@
  ;Mental Health Instruments not allowed.
  I FILENUM=601 Q 0
- I FILENUM=601.71 Q 0
  ;
  I FILENUM=790.404 Q 0
@@ -81,23 +64,19 @@
  ;
  ;==============================================
-GETFACT(PT01,ATTR,NEWPT01,NAMECHG,IEN) ;Get the action for a file.
- N ACTION,CHOICES,CSUM,DIR,FILENUM,MSG,RESULT
- N SAME,X,Y
+GETFACT(PT01,ATTR,NEWPT01,NAMECHG,EXISTS) ;Get the action for a file.
+ N ACTION,CHOICES,DIR,FILENUM,MSG,RESULT,X,Y
  ;See if this entry is already defined.
 CHK ;
  S NEWPT01=""
+ S (ATTR("NAME"),ATTR("PT01"))=PT01
  S FILENUM=ATTR("FILE NUMBER")
- I IEN="" S IEN=$$EXISTS^PXRMEXIU(FILENUM,PT01)
- I IEN D
- .;If the entry already exists compare the existing entry checksum
- .;with the packed entry checksum.
- . S CSUM=$$FILE^PXRMEXCS(ATTR("FILE NUMBER"),IEN)
- . S SAME=$S(ATTR("CHECKSUM")=CSUM:1,1:0)
- . D FEIMSG(SAME,.ATTR)
- . I SAME S ACTION="S"
- . I 'SAME D
- .. S CHOICES=$S(FILENUM=801.41:"CMOQS",FILENUM=811.5:"CMOQS",1:"COQS")
- .. S DIR("B")="O"
- .. S ACTION=$$GETACT^PXRMEXIU(CHOICES,.DIR)
+ I EXISTS="" S EXISTS=$$EXISTS^PXRMEXIU(FILENUM,PT01)
+ ;Check for identical file entry can be made here.
+ I EXISTS D
+ . W !!,ATTR("FILE NAME")," entry ",PT01," already EXISTS,"
+ . W !,"what do you want to do?"
+ . S CHOICES=$S(FILENUM=801.41:"CMOQS",FILENUM=811.5:"CMOQS",1:"COQS")
+ . S DIR("B")="S"
+ . S ACTION=$$GETACT^PXRMEXIU(CHOICES,.DIR)
  E  D
  . W !!,ATTR("FILE NAME")," entry ",PT01," is NEW,"
@@ -142,5 +121,5 @@
  ;
  ;==============================================
-SETATTR(ATTR,FILE,PT01) ;Set the file attributes for the file FILE.
+SETATTR(ATTR,FILE) ;Set the file attributes for the file FILE.
  N MSG
  S ATTR("FILE NUMBER")=FILE
@@ -149,5 +128,4 @@
  D FIELD^DID(FILE,.01,"","FIELD LENGTH","ATTR","MSG")
  S ATTR("MIN FIELD LENGTH")=3
- S (ATTR("NAME"),ATTR("PT01"))=PT01
  Q
  ;
